#include "Segment.h"

Line::Line()
{
	d = 0;
}
Line::Line(Vec2 start, Vec2 end)
{
	s = start;
	e = end;
	r = Normalize(e-s);
	n = MakeNormalForPoints(s,e);
	d = Distance(s,e);
}
scalar Line::Angle(Line l)
{
	return (acos(Dot(Normalize(s-e),Normalize(e-l.e))));//radians
}

bool LineLineOverlap(Line a, Line b, Vec2& out)
{
	if(!CollisionPrivate::LineQuickReject(a,b))
		return false;
	Vec2 s1,e1,s2,e2;
	scalar Ta,Tb;
	s1=a.s;
	s2=b.s;
	e1=a.e;
	e2=b.e;
	scalar denom, numeratorA,numeratorB;
	denom = (((e2.y-s2.y)*(e1.x-s1.x))-((e2.x-s2.x)*(e1.y-s1.y)));
	if(denom==0)//parallel
		return false;
	numeratorA = (((e2.x-s2.x)*(s1.y-s2.y))-((e2.y-s2.y)*(s1.x-s2.x)));
	numeratorB = (((e1.x-s1.x)*(s1.y-s2.y))-((e1.y-s1.y)*(s1.x-s2.x)));
	Ta = numeratorA / denom;
	Tb = numeratorB / denom;

	if((Ta>=0 && Ta<=1) && (Tb>=0 && Tb<=1))
	{
		out.x = s1.x + Ta * (e1.x-s1.x);
		out.y = s1.y + Ta * (e1.y-s1.y);
		return true;
	}
	return false;
}